MemoryHandler (Java 2 Platform SE v1.4.1_"07")

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

JavaTM 2 Platform
Std. Ed. v1.4.1_"07"

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util.logging
Class MemoryHandler

    java.lang.Object
      |
      +--java.util.logging.Handler
            |
            +--java.util.logging.MemoryHandler

public class MemoryHandler
extends Handler

`Handler` that buffers requests in a circular buffer in memory.

Normally this `Handler` simply stores incoming `LogRecords` into its memory buffer and discards earlier records. This buffering is very cheap and avoids formatting costs. On certain trigger conditions, the `MemoryHandler` will push out its current buffer contents to a target `Handler`, which will typically publish them to the outside world.

There are three main models for triggering a push of the buffer:

- An incoming `LogRecord` has a type that is greater than a pre-defined level, the `pushLevel`.
- An external class calls the `push` method explicitly.
- A subclass overrides the `log` method and scans each incoming `LogRecord` and calls `push` if a record matches some desired criteria.

Configuration: By default each `MemoryHandler` is initialized using the following LogManager configuration properties. If properties are not defined (or have invalid values) then the specified default values are used.

- java.util.logging.MemoryHandler.level specifies the level for the `Handler` (defaults to `Level.ALL`).
- java.util.logging.MemoryHandler.filter specifies the name of a `Filter` class to use (defaults to no `Filter`).
- java.util.logging.MemoryHandler.size defines the buffer size (defaults to 1000).
- java.util.logging.MemoryHandler.push defines the `pushLevel` (defaults to `level.SEVERE`).
- java.util.logging.MemoryHandler.target specifies the name of the target `Handler` class. (no default).

Since:
  1.4

Constructor Summary
`MemoryHandler()` Create a `MemoryHandler` and configure it based on `LogManager` configuration properties.
`MemoryHandler(Handler target, int size, Level pushLevel)` Create a `MemoryHandler`.

Method Summary
`void` | `close()` Close the `Handler` and free all associated resources.
`void` | `flush()` Causes a flush on the target `Handler`.
`Level` | `getPushLevel()` Get the `pushLevel`.
`boolean` | `isLoggable(LogRecord record)` Check if this `Handler` would actually log a given `LogRecord` into its internal buffer.
`void` | `publish(LogRecord record)` Store a `LogRecord` in an internal buffer.
`void` | `push()` Push any buffered output to the target `Handler`.
`void` | `setPushLevel(Level newLevel)` Set the `pushLevel`.

Methods inherited from class java.util.logging.Handler
`getEncoding, getErrorManager, getFilter, getFormatter, getLevel, reportError, setEncoding, setErrorManager, setFilter, setFormatter, setLevel`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MemoryHandler

    public MemoryHandler()

  Create a `MemoryHandler` and configure it based on `LogManager` configuration properties.

### MemoryHandler

    public MemoryHandler(Handler target,
                         int size,
                         Level pushLevel)

  Create a `MemoryHandler`.

  The `MemoryHandler` is configured based on `LogManager` properties (or their default values) except that the given `pushLevel` argument and buffer size argument are used.

Parameters:
  `target` - the Handler to which to publish output.
  `size` - the number of log records to buffer (must be greater than zero)
  `pushLevel` - message level to push on
Throws:
  `IllegalArgumentException` - is size is <= 0

Method Detail

### publish

    public void publish(LogRecord record)

  Store a `LogRecord` in an internal buffer.

  If there is a `Filter`, its `isLoggable` method is called to check if the given log record is loggable. If not we return. Otherwise the given record is copied into an internal circular buffer. Then the record's level property is compared with the `pushLevel`. If the given level is greater than or equal to the `pushLevel` then `push` is called to write all buffered records to the target output `Handler`.

  Specified by:
    `publish` in class `Handler`
  Parameters:
    `record` - description of the log event

### push

    public void push()

  Push any buffered output to the target `Handler`.

  The buffer is then cleared.

### flush

    public void flush()

  Causes a flush on the target `Handler`.

  Note that the current contents of the `MemoryHandler` buffer are not written out. That requires a "push".

  Specified by:
    `flush` in class `Handler`

### close

    public void close()
               throws SecurityException

  Close the `Handler` and free all associated resources. This will also close the target `Handler`.

  Specified by:
    `close` in class `Handler`
  Throws:
    `SecurityException` - if a security manager exists and if the caller does not have `LoggingPermission("control")`.

### setPushLevel

    public void setPushLevel(Level newLevel)
                      throws SecurityException

  Set the `pushLevel`. After a `LogRecord` is copied into our internal buffer, if its level is greater than or equal to the `pushLevel`, then `push` will be called.

  Parameters:
    `newLevel` - the new value of the `pushLevel`
  Throws:
    `SecurityException` - if a security manager exists and if the caller does not have `LoggingPermission("control")`.

### getPushLevel

    public Level getPushLevel()

  Get the `pushLevel`.

  Returns:
    the value of the `pushLevel`

### isLoggable

    public boolean isLoggable(LogRecord record)

  Check if this `Handler` would actually log a given `LogRecord` into its internal buffer.

  This method checks if the `LogRecord` has an appropriate level and whether it satisfies any `Filter`. However it does not check whether the `LogRecord` would result in a "push" of the buffer contents.

  Overrides:
    `isLoggable` in class `Handler`
  Parameters:
    `record` - a `LogRecord`
  Returns:
    true if the `LogRecord` would be logged.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

JavaTM 2 Platform
Std. Ed. v1.4.1_"07"

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2002 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms.